/**
 * Copyright (c) 2015-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 * @flow
 */
'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var React = require('react');
var assign = require('object-assign');

var HighlightHover = (function (_React$Component) {
  function HighlightHover(props) {
    _classCallCheck(this, HighlightHover);

    _get(Object.getPrototypeOf(HighlightHover.prototype), 'constructor', this).call(this, props);
    this.state = { hover: false };
  }

  _inherits(HighlightHover, _React$Component);

  _createClass(HighlightHover, [{
    key: 'render',
    value: function render() {
      var _this = this;

      return React.createElement(
        'div',
        {
          onMouseOver: function () {
            return !_this.state.hover && _this.setState({ hover: true });
          },
          onMouseOut: function () {
            return _this.state.hover && _this.setState({ hover: false });
          },
          style: assign({}, this.props.style, {
            backgroundColor: this.state.hover ? '#eee' : 'transparent' }) },
        this.props.children
      );
    }
  }]);

  return HighlightHover;
})(React.Component);

module.exports = HighlightHover;